﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;
using System.Windows.Input;
using System.Windows.Media.Imaging;

namespace Varuna.Modules.Explorer.Converters
{
    public class FileTypeToDisplayConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (((string)parameter).Equals("Image"))
            {
                if ((((FileInfo)value).Attributes & FileAttributes.Directory) != 0)
                {
                    string image;
                    try { image = Directory.GetFileSystemEntries(((FileInfo)value).FullName).Count() == 0 ? "Actions/Open" : "Support/Article"; } catch (UnauthorizedAccessException) { image = "Business Objects/BOPermission"; }
                    return new BitmapImage(new Uri($"pack://application:,,,/Images/{image}_16x16.png"));
                }
                else
                {
                    return ProcessHelper.FindIcon(((FileInfo)value).Name, false);
                }
            }
            else if (((string)parameter).Equals("Cursor"))
            {
                if ((((FileInfo)value).Attributes & FileAttributes.Directory) != 0)
                    return ((FileInfo)value).CheckAccessGranted() ? Cursors.Hand : Cursors.Arrow;
                else
                    return !String.IsNullOrEmpty(ProcessHelper.FindExecutable(((FileInfo)value).FullName)) ? Cursors.Hand : Cursors.Arrow;
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
