﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Globalization;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace Varuna.Modules.Explorer.Converters
{
    public class NavigationToDisplayConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            if (((string)parameter).ToString().Equals("Previous"))
            {
                var history = (ObservableCollection<string>)value;
                return history.Count > 0;
            }
            else if (((string)parameter).ToString().Equals("Parent"))
            {
                var dir = Directory.GetParent((string)value);
                if (dir == null) return false;
                return (dir.Attributes & FileAttributes.Directory) != 0 && dir.CheckAccessGranted();
            }

            throw new NotImplementedException();
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
